Last-Modified: Sat, 18 Jan 2025 13:09:07 GMT
Expires: Tue, 16 Jan 2035 13:09:07 GMT

<!DOCTYPE html>
<html lang='en'>
<head>
<title>raptor2-heap-overflow.patch « patches « packages « gnu - guix - Wojtek's customized Guix</title>
<meta name='generator' content='cgit v1.2.3'/>
<meta name='robots' content='noindex, nofollow'/>
<link rel='stylesheet' type='text/css' href='/cgit-static/cgit.css'/>
<link rel='stylesheet' type='text/css' href='/cgit-static/better-cgit-markdown-heading-color.css'/>
<link rel='shortcut icon' href='/cgit-static/favicon.ico'/>
<link rel='alternate' title='Atom feed' href='https://git.koszko.org/guix/atom/gnu/packages/patches/raptor2-heap-overflow.patch?h=koszko' type='application/atom+xml'/>
</head>
<body>
<div id='cgit'><table id='header'>
<tr>
<td class='logo' rowspan='2'><a href='/'><img src='https://git.koszko.org/cgit-static/cgit.png' alt='cgit logo'/></a></td>
<td class='main'><a href='/'>index</a> : <a href='/guix/'>guix</a></td><td class='form'><form method='get'>
<input type='hidden' name='id' value='9a141b5bd633227ea31776b9ce7ca40928de2442'/><select name='h' onchange='this.form.submit();'>
<option value='koszko' selected='selected'>koszko</option>
<option value='koszko-scripts'>koszko-scripts</option>
</select> <input type='submit' value='switch'/></form></td></tr>
<tr><td class='sub'>Wojtek's customized Guix</td><td class='sub righ</td></tr></table>
<table class='tabs'><tr><td>
<a href='/guix/about/'>about</a><a href='/guix/'>summary</a><a href='/guix/refs/?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>refs</a><a href='/guix/log/gnu/packages/patches/expat-CVE-2024-45491.patch'>log</a><a class='active' href='/guix/tree/gnu/packages/patches/expat-CVE-2024-45491.patch?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>tree</a><a href='/guix/commit/gnu/packages/patches/expat-CVE-2024-45491.patch?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>commit</a><a href='/guix/diff/gnu/packages/patches/expat-CVE-2024-45491.patch?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>diff</a></td><td class='form'><form class='right' method='get' action='/guix/log/gnu/packages/patches/expat-CVE-2024-45491.patch'>
<input type='hidden' name='id' value='9a141b5bd633227ea31776b9ce7ca40928de2442'/><select name='qt'>
<option value='grep'>log msg</option>
<option value='author'>author</option>
<option value='committer'>committer</option>
<option value='range'>range</option>
</select>
<input class='txt' type='search' size='10' name='q' value=''/>
<input type='submit' value='search'/>
</form>
</td></tr></table>
<div class='path'>path: <a href='/guix/tree/?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>root</a>/<a href='/guix/tree/gnu?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>gnu</a>/<a href='/guix/tree/gnu/packages?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>packages</a>/<a href='/guix/tree/gnu/packages/patches?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>patches</a>/<a href='/guix/tree/gnu/packages/patches/expat-CVE-2024-45491.patch?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>expat-CVE-2024-45491.patch</a></div><div class='content'>blob: 8ff10559bf1f0a35da69f1ac45b28303bd878048 (<a href='/guix/about/gnu/packages/patches/expat-CVE-2024-45491.patch?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>about</a>) (<a href='/guix/plain/gnu/packages/patches/expat-CVE-2024-45491.patch?id=9a141b5bd633227ea31776b9ce7ca40928de2442'>plain</a>)
<table summary='blob content' class='blob'>
<tr><td class='linenumbers'><pre><a id='n1' href='#n1'>1</a>
<a id='n2' href='#n2'>2</a>
<a id='n3' href='#n3'>3</a>
<a id='n4' href='#n4'>4</a>
<a id='n5' href='#n5'>5</a>
<a id='n6' href='#n6'>6</a>
<a id='n7' href='#n7'>7</a>
<a id='n8' href='#n8'>8</a>
<a id='n9' href='#n9'>9</a>
<a id='n10' href='#n10'>10</a>
<a id='n11' href='#n11'>11</a>
<a id='n12' href='#n12'>12</a>
<a id='n13' href='#n13'>13</a>
<a id='n14' href='#n14'>14</a>
<a id='n15' href='#n15'>15</a>
<a id='n16' href='#n16'>16</a>
<a id='n17' href='#n17'>17</a>
<a id='n18' href='#n18'>18</a>
<a id='n19' href='#n19'>19</a>
<a id='n20' href='#n20'>20</a>
<a id='n21' href='#n21'>21</a>
<a id='n22' href='#n22'>22</a>
<a id='n23' href='#n23'>23</a>
<a id='n24' href='#n24'>24</a>
<a id='n25' href='#n25'>25</a>
<a id='n26' href='#n26'>26</a>
<a id='n27' href='#n27'>27</a>
<a id='n28' href='#n28'>28</a>
<a id='n29' href='#n29'>29</a>
<a id='n30' href='#n30'>30</a>
<a id='n31' href='#n31'>31</a>
<a id='n32' href='#n32'>32</a>
<a id='n33' href='#n33'>33</a>
<a id='n34' href='#n34'>34</a>
</pre></td>
<td class='lines'><pre><code>https://github.com/libexpat/libexpat/commit/8e439a9947e9dc80a395c0c7456545d8d9d9e421.patch
Fixed in 2.6.3.

From 8e439a9947e9dc80a395c0c7456545d8d9d9e421 Mon Sep 17 00:00:00 2001
From: Sebastian Pipping &lt;sebastian@pipping.org&gt;
Date: Mon, 19 Aug 2024 22:34:13 +0200
Subject: [PATCH] lib: Detect integer overflow in dtdCopy

Reported by TaiYou
---
 expat/lib/xmlparse.c | 10 ++++++++++
 1 file changed, 10 insertions(+)

diff --git a/lib/xmlparse.c b/lib/xmlparse.c
index 91682c188..e2327bdcf 100644
--- a/lib/xmlparse.c
+++ b/lib/xmlparse.c
@@ -7016,6 +7016,16 @@ dtdCopy(XML_Parser oldParser, DTD *newDtd, const DTD *oldDtd,
     if (! newE)
       return 0;
     if (oldE-&gt;nDefaultAtts) {
+      /* Detect and prevent integer overflow.
+       * The preprocessor guard addresses the "always false" warning
+       * from -Wtype-limits on platforms where
+       * sizeof(int) &lt; sizeof(size_t), e.g. on x86_64. */
+#if UINT_MAX &gt;= SIZE_MAX
+      if ((size_t)oldE-&gt;nDefaultAtts
+          &gt; ((size_t)(-1) / sizeof(DEFAULT_ATTRIBUTE))) {
+        return 0;
+      }
+#endif
       newE-&gt;defaultAtts
           = ms-&gt;malloc_fcn(oldE-&gt;nDefaultAtts * sizeof(DEFAULT_ATTRIBUTE));
       if (! newE-&gt;defaultAtts) {
</code></pre></td></tr></table>
</div> <!-- class=content -->
                         <div class=footer>generated by
                             <a href="https://git.zx2c4.com/cgit/about/">
                                 cgit
                             </a>
                         </div>
                        </div> <!-- id=cgit -->
</body>
</html>
